diff --git a/Documentation/devicetree/bindings/regulator/mediatek,mt6366-regulator.yaml b/Documentation/devicetree/bindings/regulator/mediatek,mt6366-regulator.yaml
new file mode 100755
index 000000000000..eb72c64757cf
--- /dev/null
+++ b/Documentation/devicetree/bindings/regulator/mediatek,mt6366-regulator.yaml
@@ -0,0 +1,375 @@
+# SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)
+%YAML 1.2
+---
+$id: http://devicetree.org/schemas/regulator/mediatek,mt6366-regulator.yaml#
+$schema: http://devicetree.org/meta-schemas/core.yaml#
+
+title: MT6366 Regulator from MediaTek Integrated
+
+maintainers:
+  - Zhiyong Tao <zhiyong.tao@mediatek.com>
+
+description: |
+  List of regulators provided by this controller. It is named
+  according to its regulator type, buck_<name> and ldo_<name>.
+  MT6366 regulators node should be sub node of the MT6397 MFD node.
+
+properties:
+  compatible:
+    const: mediatek,mt6366-regulator
+
+  regulators:
+    type: object
+    description: List of regulators and its properties
+
+    patternProperties:
+      "^buck-v(dram1|core|coresshub|proc11|proc12|gpu|s2|modem|s1)$":
+        type: object
+        $ref: "regulator.yaml#"
+        unevaluatedProperties: false
+
+        properties:
+          regulator-name:
+            pattern: "^v(dram1|core|coresshub|proc11|proc12|gpu|s2|modem|s1)$"
+
+      "^ldo-v(dram2|sim1|ibr|rf12|usb|camio|camd|cn18|fe28)$":
+        type: object
+        $ref: "regulator.yaml#"
+
+        properties:
+          regulator-name:
+            pattern: "^v(dram2|sim1|ibr|rf12|usb|camio|camd|cn18|fe28)$"
+
+      "^ldo-v(xo22|efuse|mch|vcama1|emc|a12|vcama2|mc)$":
+        type: object
+        $ref: "regulator.yaml#"
+
+        properties:
+          regulator-name:
+            pattern: "^v(xo22|efuse|mch|vcama1|emc|a12|vcama2|mc)$"
+
+      "^buck-(vcore)-sshub$":
+        type: object
+        $ref: "regulator.yaml#"
+        unevaluatedProperties: false
+
+        properties:
+          regulator-name:
+            pattern: "^vcore-sshub$"
+
+      "^ldo-vcn(28|33)-bt$":
+        type: object
+        $ref: "regulator.yaml#"
+        unevaluatedProperties: false
+
+        properties:
+          regulator-name:
+            pattern: "^vcn(28|33)-bt$"
+
+      "^ldo-vcn(33)-wifi$":
+        type: object
+        $ref: "regulator.yaml#"
+        unevaluatedProperties: false
+
+        properties:
+          regulator-name:
+            pattern: "^vcn33-wifi$"
+
+      "^ldo-vsram-(others)-sshub$":
+        type: object
+        $ref: "regulator.yaml#"
+        unevaluatedProperties: false
+
+        properties:
+          regulator-name:
+            pattern: "^vsram-others-sshub$"
+
+      "^ldo-vsram-(proc11|others|gpu|proc12)$":
+        type: object
+        $ref: "regulator.yaml#"
+        unevaluatedProperties: false
+
+        properties:
+          regulator-name:
+            pattern: "^vsram-(proc11|others|gpu|proc12)$"
+
+      "^ldo-v(aud|bif|io|ldo)28$":
+        type: object
+        $ref: "regulator.yaml#"
+
+        properties:
+          regulator-name:
+            pattern: "^v(aud|bif|io|ldo)28$"
+
+      "^ldo-v(io|aux|rf)18$":
+        type: object
+        $ref: "regulator.yaml#"
+
+        properties:
+          regulator-name:
+            pattern: "^v(io|aux|rf)18$"
+
+      "^ldo-vsim[2]$":
+        type: object
+        $ref: "regulator.yaml#"
+
+        properties:
+          regulator-name:
+            pattern: "^vsim2$"
+
+        required:
+          - regulator-name
+
+required:
+  - compatible
+  - regulators
+
+additionalProperties: false
+
+examples:
+  - |
+    pmic {
+      compatible = "mediatek,mt6366-regulator";
+
+      regulators {
+        mt6366_vdram1_reg: buck-vdram1 {
+            regulator-name = "vdram1";
+            regulator-ramp-delay = <12500>;
+            regulator-enable-ramp-delay = <0>;
+            regulator-allowed-modes = <0 1>;
+        };
+
+        mt6366_vcore_reg: buck-vcore {
+            regulator-name = "vcore";
+            regulator-ramp-delay = <6250>;
+            regulator-enable-ramp-delay = <200>;
+            regulator-allowed-modes = <0 1>;
+        };
+
+       mt6366_vproc11_reg: buck-vproc11 {
+            regulator-name = "vproc11";
+            regulator-ramp-delay = <6250>;
+            regulator-enable-ramp-delay = <200>;
+            regulator-allowed-modes = <0 1>;
+        };
+
+        mt6366_vproc12_reg: buck-vproc12 {
+            regulator-name = "vproc12";
+            regulator-ramp-delay = <6250>;
+            regulator-enable-ramp-delay = <200>;
+            regulator-allowed-modes = <0 1>;
+        };
+
+        mt6366_vgpu_reg: buck-vgpu {
+            regulator-name = "vgpu";
+            regulator-ramp-delay = <6250>;
+            regulator-enable-ramp-delay = <200>;
+            regulator-allowed-modes = <0 1>;
+        };
+
+        mt6366_vs2_reg: buck-vs2 {
+            regulator-name = "vs2";
+            regulator-ramp-delay = <12500>;
+            regulator-enable-ramp-delay = <0>;
+        };
+
+       mt6366_vmodem_reg: buck-vmodem {
+            regulator-name = "vmodem";
+            regulator-ramp-delay = <6250>;
+            regulator-enable-ramp-delay = <900>;
+            regulator-allowed-modes = <0 1>;
+        };
+
+        mt6366_vs1_reg: buck-vs1 {
+            regulator-name = "vs1";
+            regulator-ramp-delay = <12500>;
+            regulator-enable-ramp-delay = <0>;
+        };
+
+        mt6366_vdram2_reg: ldo-vdram2 {
+            regulator-name = "vdram2";
+            regulator-enable-ramp-delay = <3300>;
+        };
+
+        mt6366_vsim1_reg: ldo-vsim1 {
+            regulator-name = "vsim1";
+            regulator-enable-ramp-delay = <540>;
+        };
+
+        mt6366_vibr_reg: ldo-vibr {
+            regulator-name = "vibr";
+            regulator-enable-ramp-delay = <60>;
+        };
+
+        mt6366_vrf12_reg: ldo-vrf12 {
+            compatible = "regulator-fixed";
+            regulator-name = "vrf12";
+            regulator-enable-ramp-delay = <120>;
+        };
+
+        mt6366_vio18_reg: ldo-vio18 {
+            compatible = "regulator-fixed";
+            regulator-name = "vio18";
+            regulator-enable-ramp-delay = <2700>;
+        };
+
+        mt6366_vusb_reg: ldo-vusb {
+            regulator-name = "vusb";
+            regulator-enable-ramp-delay = <270>;
+        };
+
+        mt6366_vcamio_reg: ldo-vcamio {
+            compatible = "regulator-fixed";
+            regulator-name = "vcamio";
+            regulator-enable-ramp-delay = <325>;
+        };
+
+        mt6366_vcamd_reg: ldo-vcamd {
+            regulator-name = "vcamd";
+            regulator-enable-ramp-delay = <325>;
+        };
+
+        mt6366_vcn18_reg: ldo-vcn18 {
+            compatible = "regulator-fixed";
+            regulator-name = "vcn18";
+            regulator-enable-ramp-delay = <270>;
+        };
+
+        mt6366_vfe28_reg: ldo-vfe28 {
+            compatible = "regulator-fixed";
+            regulator-name = "vfe28";
+            regulator-enable-ramp-delay = <270>;
+        };
+
+        mt6366_vsram_proc11_reg: ldo-vsram-proc11 {
+            regulator-name = "vsram-proc11";
+            regulator-ramp-delay = <6250>;
+            regulator-enable-ramp-delay = <240>;
+        };
+
+        mt6366_vcn28_reg: ldo-vcn28 {
+            compatible = "regulator-fixed";
+            regulator-name = "vcn28";
+            regulator-enable-ramp-delay = <270>;
+        };
+
+        mt6366_vsram_others_reg: ldo-vsram-others {
+            regulator-name = "vsram-others";
+            regulator-ramp-delay = <6250>;
+            regulator-enable-ramp-delay = <240>;
+        };
+
+        mt6366_vsram_gpu_reg: ldo-vsram-gpu {
+            regulator-name = "vsram-gpu";
+            regulator-ramp-delay = <6250>;
+            regulator-enable-ramp-delay = <240>;
+        };
+
+        mt6366_vxo22_reg: ldo-vxo22 {
+            compatible = "regulator-fixed";
+            regulator-name = "vxo22";
+            regulator-enable-ramp-delay = <120>;
+        };
+
+        mt6366_vefuse_reg: ldo-vefuse {
+            regulator-name = "vefuse";
+            regulator-enable-ramp-delay = <270>;
+        };
+
+        mt6366_vaux18_reg: ldo-vaux18 {
+            compatible = "regulator-fixed";
+            regulator-name = "vaux18";
+            regulator-enable-ramp-delay = <270>;
+        };
+
+        mt6366_vmch_reg: ldo-vmch {
+            regulator-name = "vmch";
+            regulator-enable-ramp-delay = <60>;
+        };
+
+        mt6366_vbif28_reg: ldo-vbif28 {
+            compatible = "regulator-fixed";
+            regulator-name = "vbif28";
+            regulator-enable-ramp-delay = <270>;
+        };
+
+        mt6366_vsram_proc12_reg: ldo-vsram-proc12 {
+            regulator-name = "vsram-proc12";
+            regulator-ramp-delay = <6250>;
+            regulator-enable-ramp-delay = <240>;
+        };
+
+        mt6366_vcama1_reg: ldo-vcama1 {
+            regulator-name = "vcama1";
+            regulator-enable-ramp-delay = <325>;
+        };
+
+        mt6366_vemc_reg: ldo-vemc {
+            regulator-name = "vemc";
+            regulator-enable-ramp-delay = <60>;
+        };
+
+        mt6366_vio28_reg: ldo-vio28 {
+            compatible = "regulator-fixed";
+            regulator-name = "vio28";
+            regulator-enable-ramp-delay = <270>;
+        };
+
+        mt6366_va12_reg: ldo-va12 {
+            compatible = "regulator-fixed";
+            regulator-name = "va12";
+            regulator-enable-ramp-delay = <270>;
+        };
+
+        mt6366_vrf18_reg: ldo-vrf18 {
+            compatible = "regulator-fixed";
+            regulator-name = "vrf18";
+            regulator-enable-ramp-delay = <120>;
+        };
+
+        mt6366_vcn33_bt_reg: ldo-vcn33-bt {
+            regulator-name = "vcn33-bt";
+            regulator-enable-ramp-delay = <270>;
+        };
+
+        mt6366_vcn33_wifi_reg: ldo-vcn33-wifi {
+            regulator-name = "vcn33-wifi";
+            regulator-enable-ramp-delay = <270>;
+        };
+
+        mt6366_vcama2_reg: ldo-vcama2 {
+            regulator-name = "vcama2";
+            regulator-enable-ramp-delay = <325>;
+        };
+
+        mt6366_vmc_reg: ldo-vmc {
+            regulator-name = "vmc";
+            regulator-enable-ramp-delay = <60>;
+        };
+
+        mt6366_vldo28_reg: ldo-vldo28 {
+            regulator-name = "vldo28";
+            regulator-enable-ramp-delay = <270>;
+        };
+
+        mt6366_vaud28_reg: ldo-vaud28 {
+            compatible = "regulator-fixed";
+            regulator-name = "vaud28";
+            regulator-enable-ramp-delay = <270>;
+        };
+
+        mt6366_vsim2_reg: ldo-vsim2 {
+            regulator-name = "vsim2";
+            regulator-enable-ramp-delay = <540>;
+        };
+
+        mt6366_vcore_sshub_reg: buck-vcore-sshub {
+            regulator-name = "vcore-sshub";
+        };
+
+        mt6366_vsram_others_sshub_reg: ldo-vsram-others-sshub {
+            regulator-name = "vsram-others-sshub";
+        };
+      };
+    };
+...